;; minimal/theme.jl

;; Made by me...

(let* (

(title-width
  (lambda (w)
  (let
      ((w-width (car (window-dimensions w))))
    (max 0 (text-width (window-name w))))))

  (update-text-width
     (lambda (w)
      (if (eq (window-get w 'current-frame-style) 'minimal)
          (rebuild-frame w))))

  (font (get-font "-b&h-lucida-bold-r-normal-*-*-80-*-*-p-*-iso8859-1"))

  (font-colors (list (get-color "#6e6e6e") (get-color "black")))

  (colors (list (get-color "darkgrey") (get-color "lightgrey")))

  (separator-colors (list (get-color "darkgrey") (get-color "black")))

  (resizer-color (list nil (get-color "black")))

(frame
 `(
   ;; Bar
   ((background . ,colors)
    (foreground . ,font-colors)
    (font . ,font)
    (text . ,window-name)
    (top-edge . -11)
    (height . 10)
    (left-edge . 12)
    (width . ,(lambda (w) (title-width w)))
    (x-justify . center)
    (y-justify . center)
    (class . title))

   ;; Separator
   ((background . ,separator-colors)
    (top-edge . -12)
    (left-edge . 11)
    (height . 12)
    (width . 1)
    (class menu-button))

   ;; Other frame borders...
   ((background . ,separator-colors)
    (top-edge . -12)
    (left-edge . 0)
    (height . 1)
    (width . ,(lambda (w) (+ (title-width w) 12))))

   ((background . ,separator-colors)
    (top-edge . -1)
    (left-edge . 0)
    (height . 1)
    (width . ,(lambda (w) (+ (title-width w) 12))))

   ((background . ,separator-colors)
    (left-edge . 0)
    (top-edge . -12)
    (width . 1)
    (height . 12))

   ((background . ,separator-colors)
    (top-edge . -12)
    (left-edge . ,(lambda (w) (+ (title-width w) 12)))
    (width . 1)
    (height . 12))

   ;; Button
   ((background . ,colors)
    (top-edge . -11)
    (left-edge . 1)
    (height . 10)
    (width . 10)
    (class . menu-button))

    ;; Resizer
    ((background . ,resizer-color)
     (bottom-edge . -1)
     (right-edge . -1)
     (height . 2)
     (width . 15)
     (class . bottom-right-corner))

    ((background . ,resizer-color)
     (bottom-edge . -1)
     (right-edge . -1)
     (height . 15)
     (width . 2)
     (class . bottom-right-corner))

))

(shaped-frame
 `(
   ;; Bar
   ((background . ,colors)
    (foreground . ,font-colors)
    (font . ,font)
    (text . ,window-name)
    (top-edge . -11)
    (height . 10)
    (left-edge . 12)
    (width . ,(lambda (w) (title-width w)))
    (x-justify . center)
    (y-justify . center)
    (class . title))

   ;; Separator
   ((background . ,separator-colors)
    (top-edge . -12)
    (left-edge . 11)
    (height . 12)
    (width . 1)
    (class menu-button))

   ;; Other frame borders...
   ((background . ,separator-colors)
    (top-edge . -12)
    (left-edge . 0)
    (height . 1)
    (width . ,(lambda (w) (+ (title-width w) 12))))

   ((background . ,separator-colors)
    (top-edge . -1)
    (left-edge . 0)
    (height . 1)
    (width . ,(lambda (w) (+ (title-width w) 12))))

   ((background . ,separator-colors)
    (left-edge . 0)
    (top-edge . -12)
    (width . 1)
    (height . 12))

   ((background . ,separator-colors)
    (top-edge . -12)
    (left-edge . ,(lambda (w) (+ (title-width w) 12)))
    (width . 1)
    (height . 12))

   ;; Button
   ((background . ,colors)
    (top-edge . -11)
    (left-edge . 1)
    (height . 10)
    (width . 10)
    (class . menu-button))
))
 
(transient-frame
 `(
   ;; Bar
   ((background . ,colors)
    (foreground . ,font-colors)
    (font . ,font)
    (text . ,window-name)
    (top-edge . -12)
    (height . 12)
    (left-edge . 0)
    (width . ,(lambda (w) (title-width w)))
    (x-justify . center)
    (y-justify . center)
    (class . title))

    ;; Other frame borders...
   ((background . ,separator-colors)
    (top-edge . -12)
    (left-edge . 0)
    (height . 1)
    (width . ,(lambda (w) (title-width w))))

   ((background . ,separator-colors)
    (top-edge . -1)
    (left-edge . 0)
    (height . 1)
    (width . ,(lambda (w) (title-width w))))

   ((background . ,separator-colors)
    (left-edge . 0)
    (top-edge . -12)
    (width . 1)
    (height . 12))

   ((background . ,separator-colors)
    (top-edge . -12)
    (left-edge . ,(lambda (w) (title-width w)))
    (width . 1)
    (height . 12)))))

  (add-frame-style 'minimal
                   (lambda (w type)
                     (cond ((eq type 'shaped)
                            shaped-frame)
                           ((eq type 'transient)
                            transient-frame)
                           ((eq type 'shaped-transient)
                            transient-frame)
                           ((eq type 'unframed)
                            nil-frame)
                           (t
                            frame))))

 (call-after-property-changed 'WM_NAME update-text-width))
